import type { InputPaths } from "@octopusdeploy/step-inputs";
import type { InitialInputs } from "./InitialInputs";
import type { PackageReference } from "@octopusdeploy/step-inputs";
import type { AvailableComponents } from "./AvailableComponents";
import { FormContent } from "./FormConent";

export interface StepUI<StepInputs> {
    editInputsForm: EditInputsForm<StepInputs>;
    createInitialInputs: (initialInputFactories: InitialInputFactories) => InitialInputs<StepInputs>;
}

export interface InitialInputFactories {
    createEmptyPackageReference: () => PackageReference;
}

export type EditInputsForm<StepInputs> = (inputPaths: InputPaths<StepInputs>, availableComponents: AvailableComponents) => FormContent[];
